package i382;

import java.net.*;
import java.io.*;

/**
 * <p>Title: Rezervan kancel</p>
 * <p>Description: Rezervan kancel po internetu</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jan Dolezel
 * @version 1.0
 * Class for comunicating of clients with server
 */

public class ClientDB extends Thread {

  //String host="localhost";
  String host="127.0.0.1";
  int port = 6789;
  Socket s = null;
  ObjectInputStream sin;
  ObjectOutputStream sout;

  /**
   * Send and recieve back informations
   * @param cmd What to send
   * @return Recieved string
   */

  public String provide(String cmd) {
    String r=null;
    try {
      sout.writeObject(cmd);
      sout.reset();
      r=(String)(sin.readObject());
    }
    catch (Exception e)  {r=e.toString();}
    return r;
  }

  /**
   * Reads data from server
   * @return Data from server
   */

  public String read() {
    String r=null;
    try {
      r=(String)(sin.readObject());
    }
    catch (Exception e)  {System.out.println(e.toString());}
    return r;
  }

  /**
   * Sends data to server
   * @param cmd What to send
   * @return OK or Error
   */

  public String write(String cmd) {
    try {
      sout.writeObject(cmd);
      sout.reset();
    }
    catch (Exception e)  {return e.toString();}
    return "OK";
  }

  /**
   * Inicialiyng sockets and creates connection to server
   */

  public ClientDB() {
    try {
      // Create connection to server
      s = new Socket(host, port);

      System.out.println("Connected to " + s.getInetAddress()
                         + ":"+ s.getPort());

      sin = new ObjectInputStream(s.getInputStream());
      sout = new ObjectOutputStream(s.getOutputStream());

// Greating form server
      String line=(String)(sin.readObject());
// Inicializing driver
      line=(String)(sin.readObject());
// Connecting to database
      line=(String)(sin.readObject());

    } catch (Exception e) {
      System.err.println("Error in connecting to database or server");
    }
  }
}