package i382;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Calendar;

/**
 * <p>Title: Rezervan kancel</p>
 * <p>Description: Rezervan kancel po internetu</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jan Dolezel
 * @version 1.0
 * Main frame of application for adding new actions
 * @see ClientDB
 */

public class Frame extends JFrame {
  ClientDB client = new ClientDB();
  JPanel contentPane;
  JSplitPane jSplitPane1 = new JSplitPane();
  JLabel jLabel1 = new JLabel();
  JComboBox Oblast = new JComboBox();
  JSplitPane jSplitPane2 = new JSplitPane();
  JLabel jLabel3 = new JLabel();
  JComboBox Kde = new JComboBox();
  JSplitPane jSplitPane3 = new JSplitPane();
  JLabel jLabel4 = new JLabel();
  JPanel jPanel2 = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JSplitPane jSplitPane4 = new JSplitPane();
  JLabel jLabel5 = new JLabel();
  JTextArea Kontakt = new JTextArea();
  JSplitPane jSplitPane5 = new JSplitPane();
  JSplitPane jSplitPane6 = new JSplitPane();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JTextField Vyzvednuti = new JTextField();
  JSplitPane jSplitPane7 = new JSplitPane();
  JTextArea CenyArea = new JTextArea();
  JSplitPane jSplitPane8 = new JSplitPane();
  JButton Uloz = new JButton();
  JButton Vymaz = new JButton();
  JSpinner Den = new JSpinner();
  JSpinner Mesic = new JSpinner();
  JSpinner Rok = new JSpinner();
  JSplitPane jSplitPane9 = new JSplitPane();
  JLabel jLabel2 = new JLabel();
  JTextField Jmeno = new JTextField();
  JTextField Vysledek = new JTextField();
  JTextField Ceny = new JTextField();
  JSplitPane jSplitPane10 = new JSplitPane();
  JLabel jLabel8 = new JLabel();
  JSplitPane jSplitPane11 = new JSplitPane();
  JTextField omezeni = new JTextField();
  JButton UlozCeny = new JButton();
  FlowLayout flowLayout2 = new FlowLayout();

  /**
   * Construct the frame and inicialize fields
   */

  public Frame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      System.err.println("Error inicializing frame");
      e.printStackTrace();
    }
    // Set date
    Den.setValue(new Integer(1));
    Mesic.setValue(new Integer(1));
    Rok.setValue(new Integer(2003));
    // Set places
    Kde.addItem("Praha");
    Kde.addItem("Stedoesk kraj");
    Kde.addItem("steck kraj");
    Kde.addItem("Libereck kraj");
    Kde.addItem("Karlovarsk kraj");
    Kde.addItem("Krlovehradeck kraj");
    Kde.addItem("Pardubick kraj");
    Kde.addItem("Plzesk kraj");
    Kde.addItem("Jihoesk kraj");
    Kde.addItem("Vysoina");
    Kde.addItem("Jihomoravsk kraj");
    Kde.addItem("Olomouck kraj");
    Kde.addItem("Moravskoslezk kraj");
    Kde.addItem("Zlnsk kraj");

    Vysledek.setText("Nepipojeno k databzi");
    // Get informations about areas of actions
    String[] oblast = client.read().split("@");
    if(oblast != null)
      for(int i=0; i < oblast.length ; i++)
        Oblast.addItem(oblast[i]);
    Vysledek.setText("Nateny oblasti");
  }

  /**
   * Component initialization - created by JBuilder
   * @throws java.lang.Exception On error
   */

  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(flowLayout2);
    this.setResizable(false);
    this.setSize(new Dimension(400, 430));
    this.setState(Frame.NORMAL);
    this.setTitle("Zadejte novou akci");
    this.addWindowListener(new Frame_this_windowAdapter(this));
    jLabel1.setPreferredSize(new Dimension(36, 15));
    jLabel1.setText("Oblast");
    jLabel3.setPreferredSize(new Dimension(36, 15));
    jLabel3.setText("Kde");
    jLabel4.setPreferredSize(new Dimension(36, 15));
    jLabel4.setText("Kdy");
    jPanel2.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.LEFT);
    flowLayout1.setHgap(5);
    flowLayout1.setVgap(0);
    jLabel5.setText("Kontakt");
    Kontakt.setDebugGraphicsOptions(0);
    Kontakt.setToolTipText("");
    Kontakt.setText("");
    Kontakt.setColumns(49);
    Kontakt.setLineWrap(true);
    Kontakt.setRows(3);
    Kontakt.setWrapStyleWord(true);
    jLabel6.setText("K vyzvednut");
    jLabel7.setText("Ceny");
    Vyzvednuti.setText("");
    CenyArea.setPreferredSize(new Dimension(390, 100));
    CenyArea.setEditable(false);
    CenyArea.setText("");
    CenyArea.setRows(6);
    Uloz.setText("Ulo");
    Uloz.addActionListener(new Frame_Uloz_actionAdapter(this));
    Vymaz.setText("Vyma ceny");
    Vymaz.addActionListener(new Frame_Vymaz_actionAdapter(this));
    jSplitPane8.setPreferredSize(new Dimension(390, 27));
    jSplitPane8.setDividerSize(5);
    Oblast.setEditable(true);
    Den.setEnabled(true);
    Den.setPreferredSize(new Dimension(45, 24));
    Den.addChangeListener(new Frame_Den_changeAdapter(this));
    Mesic.setPreferredSize(new Dimension(45, 24));
    Mesic.addChangeListener(new Frame_Mesic_changeAdapter(this));
    Rok.setPreferredSize(new Dimension(65, 24));
    Rok.addChangeListener(new Frame_Rok_changeAdapter(this));
    jLabel2.setMaximumSize(new Dimension(31, 15));
    jLabel2.setPreferredSize(new Dimension(36, 15));
    jLabel2.setText("Jmno");
    Jmeno.setText("");
    Jmeno.setColumns(40);
    Vysledek.setEnabled(true);
    Vysledek.setBorder(null);
    Vysledek.setPreferredSize(new Dimension(390, 21));
    Vysledek.setEditable(false);
    Vysledek.setText("");
    jLabel8.setText("Omezen");
    Ceny.setPreferredSize(new Dimension(180, 21));
    Ceny.setText("");
    UlozCeny.setText("Uloz");
    UlozCeny.addActionListener(new Frame_UlozCeny_actionAdapter(this));
    omezeni.setPreferredSize(new Dimension(10, 21));
    omezeni.setText("");
    flowLayout2.setAlignment(FlowLayout.LEFT);
    jSplitPane1.setPreferredSize(new Dimension(250, 23));
    jSplitPane2.setPreferredSize(new Dimension(250, 23));
    jSplitPane5.setPreferredSize(new Dimension(390, 23));
    jSplitPane5.setRequestFocusEnabled(true);
    jSplitPane6.setPreferredSize(new Dimension(390, 33));
    jSplitPane3.setPreferredSize(new Dimension(220, 26));
    contentPane.add(jSplitPane9, null);
    jSplitPane9.add(jLabel2, JSplitPane.LEFT);
    jSplitPane9.add(Jmeno, JSplitPane.RIGHT);
    contentPane.add(jSplitPane1, null);
    jSplitPane1.add(jLabel1, JSplitPane.LEFT);
    jSplitPane1.add(Oblast, JSplitPane.RIGHT);
    contentPane.add(jSplitPane2, null);
    jSplitPane2.add(jLabel3, JSplitPane.LEFT);
    jSplitPane2.add(Kde, JSplitPane.RIGHT);
    contentPane.add(jSplitPane3, null);
    jSplitPane3.add(jLabel4, JSplitPane.LEFT);
    jSplitPane3.add(jPanel2, JSplitPane.RIGHT);
    jPanel2.add(Den, null);
    jPanel2.add(Mesic, null);
    jPanel2.add(Rok, null);
    contentPane.add(jSplitPane4, null);
    jSplitPane4.add(jLabel5, JSplitPane.LEFT);
    jSplitPane4.add(Kontakt, JSplitPane.RIGHT);
    contentPane.add(jSplitPane5, null);
    jSplitPane5.add(jLabel6, JSplitPane.LEFT);
    jSplitPane5.add(Vyzvednuti, JSplitPane.RIGHT);
    contentPane.add(jSplitPane6, null);
    jSplitPane6.add(jLabel7, JSplitPane.LEFT);
    jSplitPane6.add(jSplitPane7, JSplitPane.RIGHT);
    jSplitPane7.add(Ceny, JSplitPane.LEFT);
    jSplitPane7.add(jSplitPane10, JSplitPane.RIGHT);
    jSplitPane10.add(jLabel8, JSplitPane.LEFT);
    contentPane.add(CenyArea, null);
    contentPane.add(jSplitPane8, null);
    jSplitPane8.add(Uloz, JSplitPane.LEFT);
    jSplitPane8.add(Vymaz, JSplitPane.RIGHT);
    contentPane.add(Vysledek, null);
    jSplitPane10.add(jSplitPane11, JSplitPane.RIGHT);
    jSplitPane11.add(omezeni, JSplitPane.LEFT);
    jSplitPane11.add(UlozCeny, JSplitPane.RIGHT);
    jSplitPane7.setDividerLocation(200);
    jSplitPane8.setDividerLocation(200);
    jSplitPane11.setDividerLocation(25);
    jSplitPane3.setDividerLocation(37);
  }

  /**
   * Overridden so we can exit when window is closed
   */

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  /**
   * Reaction on clicking Uloz button nexto field Ceny
   * Saving prices to list
   */

  void UlozCeny_actionPerformed(ActionEvent e) {
    if(Ceny.getText().indexOf("@") != -1) {
      Vysledek.setText("V dnm daji se nesm vyskytnout znak @");
      return;
    }
    if(Ceny.getText().indexOf("'") != -1) {
      Vysledek.setText("V dnm daji se nesm vyskytnout znak '");
      return;
    }
    if(Ceny.getText().indexOf(";") != -1) {
      Vysledek.setText("V kolonce cena se nesm vyskytnout znak ;");
      return;
    }
    if(!omezeni.getText().equals("")) {
      try {
        Integer.parseInt(omezeni.getText());
      }
      catch (Exception ex) {
          Vysledek.setText("V kolonce omezen mus bt platn slo nebo nic");
          return;
      }
    }
    else {
      // char representing unlimited tickets
      omezeni.setText("x");
    }
    if(!Ceny.getText().equals(""))
      CenyArea.insert(Ceny.getText() + ";" + omezeni.getText() + "\n",0);
    Ceny.setText("");
    omezeni.setText("");
  }

  /**
   * Response to change of date
   * Correcting the date
   */

  void Datum_stateChanged(ChangeEvent e) {
    int i = Integer.parseInt(Den.getValue().toString());
    int m = Integer.parseInt(Mesic.getValue().toString());
    int r = Integer.parseInt(Rok.getValue().toString());
    boolean prestupny = false;

    if(m < 1)
      Mesic.setValue(new Integer(1));
    if(m > 12)
       Mesic.setValue(new Integer(12));
    if(i < 1)
       Den.setValue(new Integer(1));
    if(i > 31)
       Den.setValue(new Integer(31));
    if((i>30)&&((m==4)||(m==6)||(m==9)||(m==11)))
       Den.setValue(new Integer(30));
    if((m==2)&&(i>29))
      Den.setValue(new Integer(29));
    prestupny = (r%400 == 0)? false: (r%4 == 0)? true: false;
    if((m==2)&& !prestupny && (i>28))
      Den.setValue(new Integer(28));
  }

  /**
   * Response to clicking on Vymaz button
   * Clearing list of prices
   */

  void Vymaz_actionPerformed(ActionEvent e) {
    CenyArea.setText("");
  }

  /**
   * Response to clicking on Uloz button
   * Sending informations about new action to server
   */

  void Uloz_actionPerformed(ActionEvent e) {
    if(Jmeno.getText().equals("")) {
       Vysledek.setText("Muste vyplnit daj Jmno");
       return;
    }
    if(Jmeno.getText().indexOf("@") != -1) {
       Vysledek.setText("V dnm daji se nesm vyskytnout znak @");
       return;
    }
    if(Jmeno.getText().indexOf("%") != -1) {
       Vysledek.setText("V dnm daji se nesm vyskytnout znak *");
       return;
    }
    if(Jmeno.getText().indexOf("'") != -1) {
      Vysledek.setText("V dnm daji se nesm vyskytnout znak '");
      return;
    }
    if(Kontakt.getText().equals("")) {
      Vysledek.setText("Muste vyplnit kontaktn adresu nebo msto");
      return;
    }
    if(Kontakt.getText().indexOf("@") != -1) {
       Vysledek.setText("V dnm daji se nesm vyskytnout znak @");
       return;
    }
    if(Kontakt.getText().indexOf("'") != -1) {
      Vysledek.setText("V dnm daji se nesm vyskytnout znak '");
      return;
    }
    if(Vyzvednuti.getText().equals("")) {
       Vysledek.setText("Muste vyplnit kde se daj vstupenky vyzvednout");
       return;
    }
    if(Vyzvednuti.getText().indexOf("@") != -1) {
       Vysledek.setText("V dnm daji se nesm vyskytnout znak @");
       return;
    }
    if(Vyzvednuti.getText().indexOf("'") != -1) {
      Vysledek.setText("V dnm daji se nesm vyskytnout znak '");
      return;
    }
    if(CenyArea.getText().equals("")) {
      Vysledek.setText("Muste zadat alespo jednu cenu");
      return;
    }
    if(Jmeno.getText().length() > 50) {
      Vysledek.setText("Jmno je moc dlouh (max. 50 znak)");
      return;
    }
    if(((String)Oblast.getSelectedItem()).length() > 20) {
      Vysledek.setText("Nzev oblasti je moc dlouh (max. 20 znak)");
      return;
    }
    if(Kontakt.getText().length() > 255) {
      Vysledek.setText("Kontakt je moc dlouh (max. 255 znak)");
      return;
    }
    if(Ceny.getText().length() > 255) {
      Vysledek.setText("Cen je moc (max. 255 znak)");
      return;
    }

    // Formating string for sending
    String s= "Novy@" + Jmeno.getText() + "@" + Oblast.getSelectedItem() +
       "@" + Kde.getSelectedItem() + "@" + Rok.getValue() + "-" +
       Mesic.getValue() + "-" + Den.getValue() + "@" + Vyzvednuti.getText() +
       "@" + Kontakt.getText() + "@" + CenyArea.getText();
    Vysledek.setText(client.provide(s));
  }

  /**
   * When exiting application - close connection
   */

  void this_windowClosing(WindowEvent e) {
    client.provide("Closing");
  }
}

class Frame_Den_changeAdapter implements javax.swing.event.ChangeListener {
  Frame adaptee;

  Frame_Den_changeAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void stateChanged(ChangeEvent e) {
    adaptee.Datum_stateChanged(e);
  }
}

class Frame_Mesic_changeAdapter implements javax.swing.event.ChangeListener {
  Frame adaptee;

  Frame_Mesic_changeAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void stateChanged(ChangeEvent e) {
    adaptee.Datum_stateChanged(e);
  }
}

class Frame_Rok_changeAdapter implements javax.swing.event.ChangeListener {
  Frame adaptee;

  Frame_Rok_changeAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void stateChanged(ChangeEvent e) {
    adaptee.Datum_stateChanged(e);
  }
}

class Frame_Vymaz_actionAdapter implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_Vymaz_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.Vymaz_actionPerformed(e);
  }
}

class Frame_Uloz_actionAdapter implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_Uloz_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.Uloz_actionPerformed(e);
  }
}

class Frame_this_windowAdapter extends java.awt.event.WindowAdapter {
  Frame adaptee;

  Frame_this_windowAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void windowClosing(WindowEvent e) {
    adaptee.this_windowClosing(e);
  }
}

class Frame_UlozCeny_actionAdapter implements java.awt.event.ActionListener {
  Frame adaptee;

  Frame_UlozCeny_actionAdapter(Frame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.UlozCeny_actionPerformed(e);
  }
}